UNIT Unc;

{$I OsWahl.inc}

{$IFDEF DOS} {$M 65520,0,655360} {$N+}
{$ELSE} {$mode objfpc} {$H-}
        {$IFDEF X86_64} {$MAXSTACKSIZE $7FFFFFF} {$ENDIF}
{$ENDIF}

INTERFACE

VAR zeichensatz, zeichensatz1, zeichensatz2,
    _ae, _oe, _ue, _AE2, _OE2, _UE2, _sz, _eu, _gr, _h2, _h3, _pg : STRING;

FUNCTION uml(nr: BYTE):STRING;
(* Umlaute ueber chr *)

IMPLEMENTATION

FUNCTION uml(nr: BYTE):STRING;
BEGIN
   CASE nr OF
     (* SZ CP850: E1/225 CP1252: DF/223 UTF8: C3+9F/195+159 *)
     0 : uml:={$IFDEF LINUX} chr(195) + chr(159) {$ELSE}
              '' + chr( {$IFDEF DOS} 225 {$ELSE} 223 {$ENDIF} ) {$ENDIF} ;

     (* AE CP850: 8E/142 CP1252: C4/196 UTF8: C3+84/195+132 *)
     1 : uml:={$IFDEF LINUX} chr(195) + chr(132) {$ELSE}
              '' + chr( {$IFDEF DOS} 142 {$ELSE} 196 {$ENDIF} ) {$ENDIF} ;

     (* OE CP850: 99/153 CP1252: D6/214 UTF8: C3+96/195+150 *)
     2 : uml:={$IFDEF LINUX} chr(195) + chr(150) {$ELSE}
              '' + chr( {$IFDEF DOS} 153 {$ELSE} 214 {$ENDIF} ) {$ENDIF} ;

     (* UE CP850: 9A/154 CP1252: DC/220 UTF8: C3+9C/195+156 *)
     3 : uml:={$IFDEF LINUX} chr(195) + chr(156) {$ELSE}
              '' + chr( {$IFDEF DOS} 154 {$ELSE} 220 {$ENDIF} ) {$ENDIF} ;

     (* ae CP850: 84/132 CP1252: E4/228 UTF8: C3+A4/195+164 *)
    11 : uml:={$IFDEF LINUX} chr(195) + chr(164) {$ELSE}
              '' + chr( {$IFDEF DOS} 132 {$ELSE} 228 {$ENDIF} ) {$ENDIF} ;

     (* oe CP850: 94/148 CP1252: F6/246 UTF8: C3+B6/195+182 *)
    12 : uml:={$IFDEF LINUX} chr(195) + chr(182) {$ELSE}
              '' + chr( {$IFDEF DOS} 148 {$ELSE} 246 {$ENDIF} ) {$ENDIF} ;

     (* ue CP850: 81/129 CP1252: FC/252 UTF8: C3+BC/195+188 *)
    13 : uml:={$IFDEF LINUX} chr(195) + chr(188) {$ELSE}
              '' + chr( {$IFDEF DOS} 129 {$ELSE} 252 {$ENDIF} ) {$ENDIF} ;

     (* eu CP850: 9D/157 CP1252: 80/128 UTF8: E2+82+AC/226+130+172 *)
    21 : uml:={$IFDEF LINUX} chr(226) + chr(130) + chr(172) {$ELSE}
              '' + chr( {$IFDEF DOS} 157 {$ELSE} 128 {$ENDIF} ) {$ENDIF} ;

     (* gr CP850: F2/242 CP1252: FC/248 UTF8: C2+B0/194+176 *)
    22 : uml:={$IFDEF LINUX} chr(194) + chr(176) {$ELSE}
              '' + chr( {$IFDEF DOS} 242 {$ELSE} 248 {$ENDIF} ) {$ENDIF} ;

     (* h2 CP850: F3/243 CP1252: FC/253 UTF8: C2+B2/194+178 *)
    23 : uml:={$IFDEF LINUX} chr(194) + chr(178) {$ELSE}
              '' + chr( {$IFDEF DOS} 243 {$ELSE} 253 {$ENDIF} ) {$ENDIF} ;

     (* h3 CP850: F8/248 CP1252: FC/252 UTF8: C2+B3/194+179 *)
    24 : uml:={$IFDEF LINUX} chr(194) + chr(179) {$ELSE}
              '' + chr( {$IFDEF DOS} 248 {$ELSE} 252 {$ENDIF} ) {$ENDIF} ;

     (* pg CP850: A7/167 CP1252: FC/245 UTF8: C2+A7/194+167 *)
    25 : uml:={$IFDEF LINUX} chr(194) + chr(167) {$ELSE}
              '' + chr( {$IFDEF DOS} 167 {$ELSE} 245  {$ENDIF} ) {$ENDIF} ;
    ELSE uml:='';
   END
END;

BEGIN
  _ae:= uml(1);
  _oe:= uml(2);
  _ue:= uml(3);
  _AE2:=uml(11);
  _OE2:=uml(12);
  _UE2:=uml(13);
  _sz:= uml(0);
  _eu:= uml(21);
  _gr:= uml(22);
  _h2:= uml(23);
  _h3:= uml(24);
  _pg:= uml(25);
  zeichensatz:= 'ABCDEFGHIJKLMNOPQRSTUVWXYYZabcdefghijklmnopqrstuvwxyz1234567890!"$%&/()=?`[]{}\+*~''#,.-;:_<>|';
  zeichensatz1:=zeichensatz + _ae + _oe + _ue + _AE2 + _OE2 + _UE2 + _sz + _eu + _gr + _h2 + _h3 + _pg;
  zeichensatz2:=zeichensatz + uml(1)+ uml(2)+ uml(3)+ uml(11)+ uml(12)+ uml(13)+ uml(0) + _eu + _gr + _h2 + _h3 + _pg;
END.
